startnivaa_inn = xlsread('nivaa_tyin_pumping',3,'C2:I5881'); % tar inn niv for Tyin
tilsig_inn = xlsread('inndata_lokaltilsig',1,'D2881:H8760'); % tar inn tilsig til Torolmen
pumper = xlsread('inndata_lokaltilsig',3,'C3:F7'); % tar inn data om pumpene
dato = xlsread('inndata_lokaltilsig',4,'B2:B5881');
pris_inn = xlsread('inndata_lokaltilsig',4,'C2:I5881'); % tar inn spotpriser for omrdet


RKM = input('RKM?: ');

A = [2006 2007 2008 2009 2010 2011];
for k = 1: length(A)
  
switch A(k)
    case 2006
        startnivaa = startnivaa_inn(:,2);
        tilsig = tilsig_inn(:,1);
        pris = pris_inn(:,2);
    case 2007
        startnivaa = startnivaa_inn(:,3);
        tilsig = tilsig_inn(:,2);
        pris = pris_inn(:,3);
    case 2008
        startnivaa = startnivaa_inn(:,4);
        tilsig = xlsread('inndata_lokaltilsig',1,'K2905:H8784');
        pris = pris_inn(:,4);
    case 2009
        startnivaa = startnivaa_inn(:,5);
        tilsig = tilsig_inn(:,3);
        pris = pris_inn(:,5);
    case 2010
        startnivaa = startnivaa_inn(:,6);
        tilsig = tilsig_inn(:,4);
        pris = pris_inn(:,6);
    case 2011
        startnivaa = startnivaa_inn(:,7);
        tilsig = tilsig_inn(:,5);
        pris = pris_inn(:,7);
end

average = (sum(pris)/length(pris));


timer = length(startnivaa);
pumpeantall = length(pumper);

hrv_tyin_pumpe = 1082;
hrv_tyin = 1083.89;
lrv_tyin = 1073.55;
hrv_tor = 1050.8;
lrv_tor = 1047.8;

vgr_pumpe = 0.9;

nivaa_magvol = zeros(timer,pumpeantall);
nytt_magvol = zeros(timer,pumpeantall);
nytt_nivaa = zeros(timer,pumpeantall);

vgrad = zeros(timer,pumpeantall);
qtabell = zeros(timer,pumpeantall);
binary = zeros(timer,pumpeantall);
binary_tyin = zeros(timer,pumpeantall);
nivaatabell_tor = zeros(timer,pumpeantall);
magtabell_tyin = zeros(timer,pumpeantall);
magtabell_tor = zeros(timer,pumpeantall);

qmax = pumper(:,1);
qmin = pumper(:,2);
qbest = pumper(:,3);
minstevol = pumper(:,4);
qtyin_max = 40;

qp = zeros(timer,1);
qtyin = zeros(timer,1);

for i = 1:pumpeantall
    lager = 0;
    ekstra = 0;
    torolmen(1,1) = 1047.8;
    torolmen(1,2) = 0;
    
    for j = 2:timer
    
        qp(j) = 0; 
        qtyin(j) = 0;
        pumpe=0;
        kjore=0;
        
        
        if (pris(j) < average)
            switch RKM
                case 1
            if (tilsig(j)>qbest(i))
                qp(j)=qbest(i);
                pumpe = 1;
                if (tilsig(j)-qbest(i)> 3)
                qtyin(j) = tilsig(j) - qbest(i);
                kjoring = 1;
                end
            elseif torolmen(1,2)> minstevol(i)
                qp(j) = qbest(i);
                pumpe = 1;
            end
                case 0
            if (tilsig(j)>qbest(i) || torolmen(1,2)> minstevol(i) )
                qp(j)=qbest(i);
                pumpe = 1;
            end
            
            end
            
            
        elseif (pris(j) > average)
            if(torolmen(1,2) > qtyin_max*3600*10^(-6))
                qtyin(j) = qtyin_max;
                kjore = 1;
            end
        end
        
        if (nytt_nivaa(j-1,i) > hrv_tyin_pumpe)
            qp(j)=0;           
            pumpe = 2;
          
        end
        
        if (torolmen(1,1)> hrv_tor )
           qtyin(j) = qtyin_max; 
           kjore = 2;
        end
        
            lager = lager + qp(j)*3600/10^6;
            nivaa_magvol(j,i) = magvol_tyin(startnivaa(j)); 
            nytt_magvol(j,i) = nivaa_magvol(j,i) + lager;
            nytt_nivaa(j,i) = nivaa_tyin(nytt_magvol(j,i));

            
            ekstra = (tilsig(j)*3600*10^(-6))-(qp(j)*3600*10^(-6))-(qtyin(j)*3600*10^(-6));
            torolmen(1,2) = torolmen(1,2) + ekstra ; 
            torolmen(1,1) = nivaa_torolmen(torolmen(1,2));
       
            
             qtabell(j,i) = qp(j);    
             vgrad(j,i) = vgr_pumpe; 
             nivaatabell_tor(j,i) = torolmen(1,1);
             magtabell_tor(j,i) = torolmen(1,2);
             binary(j,i) = pumpe;
             binary_tyin(j,i) = kjore;
            
    end

end

switch A(k)
    case 2006
        xlswrite('2006_utdata_pumpe',vgrad,1,'C2');
        xlswrite('2006_utdata_pumpe',qtabell,1,'I2');
        xlswrite('2006_utdata_pumpe',nytt_nivaa,2,'C2');
        xlswrite('2006_utdata_pumpe',nivaatabell_tor,2,'I2');
        xlswrite('2006_utdata_pumpe',nytt_magvol,3,'C2');
        xlswrite('2006_utdata_pumpe',magtabell_tor,3,'I2');
        xlswrite('2006_utdata_pumpe',binary,3,'O2');
        xlswrite('2006_utdata_pumpe',binary_tyin,7,'B2');        
    case 2007
        xlswrite('2007_utdata_pumpe',vgrad,1,'C2');
        xlswrite('2007_utdata_pumpe',qtabell,1,'I2');
        xlswrite('2007_utdata_pumpe',nytt_nivaa,2,'C2');
        xlswrite('2007_utdata_pumpe',nivaatabell_tor,2,'I2');
        xlswrite('2007_utdata_pumpe',nytt_magvol,3,'C2');
        xlswrite('2007_utdata_pumpe',magtabell_tor,3,'I2');
        xlswrite('2007_utdata_pumpe',binary,3,'O2');
        xlswrite('2007_utdata_pumpe',binary_tyin,7,'B2');
    case 2008
        xlswrite('2008_utdata_pumpe',vgrad,1,'C2');
        xlswrite('2008_utdata_pumpe',qtabell,1,'I2');
        xlswrite('2008_utdata_pumpe',nytt_nivaa,2,'C2');
        xlswrite('2008_utdata_pumpe',nivaatabell_tor,2,'I2');
        xlswrite('2008_utdata_pumpe',nytt_magvol,3,'C2');
        xlswrite('2008_utdata_pumpe',magtabell_tor,3,'I2');
        xlswrite('2008_utdata_pumpe',binary,3,'O2');
        xlswrite('2008_utdata_pumpe',binary_tyin,7,'B2');        
    case 2009
        xlswrite('2009_utdata_pumpe',vgrad,1,'C2');
        xlswrite('2009_utdata_pumpe',qtabell,1,'I2');
        xlswrite('2009_utdata_pumpe',nytt_nivaa,2,'C2');
        xlswrite('2009_utdata_pumpe',nivaatabell_tor,2,'I2');
        xlswrite('2009_utdata_pumpe',nytt_magvol,3,'C2');
        xlswrite('2009_utdata_pumpe',magtabell_tor,3,'I2');
        xlswrite('2009_utdata_pumpe',binary,3,'O2');
        xlswrite('2009_utdata_pumpe',binary_tyin,7,'B2');
    case 2010
        xlswrite('2010_utdata_pumpe',vgrad,1,'C2');
        xlswrite('2010_utdata_pumpe',qtabell,1,'I2');
        xlswrite('2010_utdata_pumpe',nytt_nivaa,2,'C2');
        xlswrite('2010_utdata_pumpe',nivaatabell_tor,2,'I2');
        xlswrite('2010_utdata_pumpe',nytt_magvol,3,'C2');
        xlswrite('2010_utdata_pumpe',magtabell_tor,3,'I2');
        xlswrite('2010_utdata_pumpe',binary,3,'O2');
        xlswrite('2010_utdata_pumpe',binary_tyin,7,'B2');
    case 2011
        xlswrite('2011_utdata_pumpe',vgrad,1,'C2');
        xlswrite('2011_utdata_pumpe',qtabell,1,'I2');
        xlswrite('2011_utdata_pumpe',nytt_nivaa,2,'C2');
        xlswrite('2011_utdata_pumpe',nivaatabell_tor,2,'I2');
        xlswrite('2011_utdata_pumpe',nytt_magvol,3,'C2');
        xlswrite('2011_utdata_pumpe',magtabell_tor,3,'I2');
        xlswrite('2011_utdata_pumpe',binary,3,'O2');
        xlswrite('2011_utdata_pumpe',binary_tyin,7,'B2');
end
end

